/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest{}

// AppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest struct for AppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest
type AppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest struct {
	Service *string                      `json:"service,omitempty"`
	Data    *SnapchatStaticDtoAuthorizer `json:"data,omitempty"`
}

// NewAppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest instantiates a new AppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest() *AppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest {
	this := AppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest{}
	var service string = "snapchat_static"
	this.Service = &service
	return &this
}

// NewAppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequestWithDefaults instantiates a new AppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequestWithDefaults() *AppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest {
	this := AppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest{}
	var service string = "snapchat_static"
	this.Service = &service
	return &this
}

// GetService returns the Service field value if set, zero value otherwise.
func (o *AppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest) GetService() string {
	if o == nil || IsNil(o.Service) {
		var ret string
		return ret
	}
	return *o.Service
}

// GetServiceOk returns a tuple with the Service field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest) GetServiceOk() (*string, bool) {
	if o == nil || IsNil(o.Service) {
		return nil, false
	}
	return o.Service, true
}

// HasService returns a boolean if a field has been set.
func (o *AppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest) HasService() bool {
	if o != nil && !IsNil(o.Service) {
		return true
	}

	return false
}

// SetService gets a reference to the given string and assigns it to the Service field.
func (o *AppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest) SetService(v string) {
	o.Service = &v
}

// GetData returns the Data field value if set, zero value otherwise.
func (o *AppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest) GetData() SnapchatStaticDtoAuthorizer {
	if o == nil || IsNil(o.Data) {
		var ret SnapchatStaticDtoAuthorizer
		return ret
	}
	return *o.Data
}

// GetDataOk returns a tuple with the Data field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest) GetDataOk() (*SnapchatStaticDtoAuthorizer, bool) {
	if o == nil || IsNil(o.Data) {
		return nil, false
	}
	return o.Data, true
}

// HasData returns a boolean if a field has been set.
func (o *AppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest) HasData() bool {
	if o != nil && !IsNil(o.Data) {
		return true
	}

	return false
}

// SetData gets a reference to the given SnapchatStaticDtoAuthorizer and assigns it to the Data field.
func (o *AppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest) SetData(v SnapchatStaticDtoAuthorizer) {
	o.Data = &v
}

func (o AppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Service) {
		toSerialize["service"] = o.Service
	}
	if !IsNil(o.Data) {
		toSerialize["data"] = o.Data
	}
	return toSerialize, nil
}

type NullableAppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest struct {
	value *AppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest
	isSet bool
}

func (v NullableAppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest) Get() *AppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest {
	return v.value
}

func (v *NullableAppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest) Set(val *AppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableAppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableAppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest(val *AppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest) *NullableAppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest {
	return &NullableAppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest{value: val, isSet: true}
}

func (v NullableAppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAppAuthorizerSnapchatStaticSnapchatStaticAuthorizerNewRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
